function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
/* eslint-disable @typescript-eslint/no-explicit-any */
/* eslint-disable no-plusplus */
/* eslint-disable no-underscore-dangle */
var EventEmitter = /*#__PURE__*/function () {
  function EventEmitter() {
    _classCallCheck(this, EventEmitter);
    _defineProperty(this, "_listeners", []);
    _defineProperty(this, "_event", void 0);
    _defineProperty(this, "_disposed", false);
  }
  _createClass(EventEmitter, [{
    key: "event",
    get: function get() {
      var _this = this;
      if (!this._event) {
        this._event = function (listener) {
          _this._listeners.push(listener);
          var disposable = {
            dispose: function dispose() {
              if (!_this._disposed) {
                for (var i = 0; i < _this._listeners.length; i++) {
                  if (_this._listeners[i] === listener) {
                    _this._listeners.splice(i, 1);
                    return;
                  }
                }
              }
            }
          };
          return disposable;
        };
      }
      return this._event;
    }
  }, {
    key: "fire",
    value: function fire(arg1, arg2) {
      var queue = [];
      for (var i = 0; i < this._listeners.length; i++) {
        queue.push(this._listeners[i]);
      }
      for (var _i = 0; _i < queue.length; _i++) {
        queue[_i].call(undefined, arg1, arg2);
      }
    }
  }, {
    key: "dispose",
    value: function dispose() {
      if (this._listeners) {
        this._listeners.length = 0;
      }
      this._disposed = true;
    }
  }]);
  return EventEmitter;
}();
export default EventEmitter;