function LogWorker() {
  var workerPath = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '/worker';
  var worker = null;
  var version = "2.0.4" || '0.0.0';
  var path = workerPath.includes('http') ? "".concat(workerPath, "/log.worker.js") : "".concat(window.location.origin).concat(workerPath, "/log.worker.js");
  var blob = new Blob(["importScripts(\"".concat(path, "?v=").concat(version, "\")")], {
    type: 'application/javascript'
  });
  var blobUrl = window.URL.createObjectURL(blob);
  worker = new Worker(blobUrl);
  return worker;
}
export default LogWorker;