import { ISearchOptions } from '../SearchAddon';
export default class Searcher {
    private options;
    constructor(options?: {
        markClassName: string;
        markedClassName: string;
    });
    search(keyword: string, logs: Array<string>, hlIndex?: number, options?: ISearchOptions | undefined): {
        count: number;
        map: {
            [key: string]: string;
            [key: number]: string;
        };
        markedKey: number;
    };
}
