function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
/* eslint-disable @typescript-eslint/no-explicit-any */
var WebWorkerClient = /*#__PURE__*/function () {
  function WebWorkerClient(worker) {
    var _this = this;
    _classCallCheck(this, WebWorkerClient);
    _defineProperty(this, "events", void 0);
    _defineProperty(this, "worker", void 0);
    this.events = {};
    this.worker = worker;
    this.worker.onmessage = function (e) {
      var topic = e.data.topic;
      _this.exec(topic, e.data);
    };
  }
  _createClass(WebWorkerClient, [{
    key: "once",
    value: function once(topic, callback) {
      var _this2 = this;
      var on = function on(args) {
        _this2.off(topic, on);
        callback(args);
      };
      return this.on(topic, on);
    }
  }, {
    key: "on",
    value: function on(topic, callback) {
      if (!this.events[topic]) {
        this.events[topic] = [];
      }
      this.events[topic].push(callback);
      return this;
    }
  }, {
    key: "off",
    value: function off(topic, callback) {
      if (!Array.isArray(this.events[topic])) {
        return this;
      }
      this.events[topic] = this.events[topic].filter(function (f) {
        return f !== callback;
      });
      return this;
    }
  }, {
    key: "exec",
    value: function exec(topic, data) {
      if (!Array.isArray(this.events[topic])) {
        return this;
      }
      this.events[topic].forEach(function (callback) {
        callback(data);
      });
      return this;
    }
  }, {
    key: "send",
    value: function send(topic) {
      var payload = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      this.worker.postMessage(_objectSpread({
        topic: topic
      }, payload));
      return this;
    }
  }, {
    key: "terminate",
    value: function terminate() {
      this.worker.terminate();
      return this;
    }
  }]);
  return WebWorkerClient;
}();
export default WebWorkerClient;