function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
/* eslint-disable no-plusplus */
// eslint-disable-next-line import/no-named-default
import { default as AnsiUp } from 'ansi_up';
import LimitMap from "./LimitMap";
import Searcher from "./Searcher";
var Logs = /*#__PURE__*/function () {
  function Logs(_ref) {
    var id = _ref.id,
      string = _ref.string;
    _classCallCheck(this, Logs);
    _defineProperty(this, "id", void 0);
    _defineProperty(this, "string", void 0);
    _defineProperty(this, "searcher", void 0);
    _defineProperty(this, "logDataMap", void 0);
    this.id = id;
    this.string = string;
    this.searcher = new Searcher();
    this.logDataMap = new LimitMap({
      limit: 1
    });
  }
  _createClass(Logs, [{
    key: "convert",
    value: function convert() {
      if (this.string.length === 0) {
        return [];
      }
      return this.string.split('\r\n').map(function (content) {
        return new AnsiUp().ansi_to_html(content);
      });
    }
  }, {
    key: "getArrayData",
    value: function getArrayData() {
      if (!this.logDataMap.has(this.id)) {
        this.logDataMap.set(this.id, this.convert());
      }
      return this.logDataMap.get(this.id) || [];
    }
  }, {
    key: "mark",
    value: function mark(keyword) {
      var hlIndex = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
      var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : undefined;
      if (!keyword) {
        return this.searcher.search(keyword, []);
      }
      return this.searcher.search(keyword, this.getArrayData(), hlIndex, options);
    }
  }]);
  return Logs;
}();
export { Logs as default };