type Callback = (args: any) => void;
declare class WebWorkerClient {
    private events;
    private worker;
    constructor(worker: Worker);
    once(topic: string, callback: Callback): this;
    on(topic: string, callback: Callback): this;
    off(topic: string, callback: Callback): this;
    exec(topic: string, data: any): this;
    send(topic: string, payload?: {}): this;
    terminate(): this;
}
export default WebWorkerClient;
